const tools = require("../script/tools");


cc.Class({
    extends: cc.Component,

    properties: {
        label: cc.Label
    },

    data: null,

    onLoad() {

    },

    onEnable() {
        this.node.on(cc.Node.EventType.TOUCH_START, this.onTouchStart, this)
    },

    onDisable() {
        this.node.off(cc.Node.EventType.TOUCH_START, this.onTouchStart, this)
    },

    initWithData(data) {
        this.data = data
        let rect = this.data.rect
        this.node.x = rect.x + rect.width / 2
        this.node.y = -rect.y - rect.height / 2
        this.node.width = rect.width
        this.node.height = rect.height
        this.label = data.text
        this.audioId = null
    },

    onTouchStart() {
        if (this.audioId) return
        if (this.data) {
            let url = this.data.audio_url
            if (url && url != '') {
                this.playAudio(url)
                this.tipsAnim.node.active = true
                this.tipsAnim.play()
            }
            cc.audioEngine.play(this.tipClip)
        }
    },

    /** 播放音乐 */
    playAudio(url) {
        cc.assetManager.loadRemote(url, (err, audioClip) => {
            if (err) return
            cc.systemEvent.once('stopMusic', this.stopAudio, this)
            this.audioId = cc.audioEngine.play(audioClip, false, 0.8);
            cc.audioEngine.setFinishCallback(this.audioId, this.stopAudio.bind(this));
        });
    },

    stopAudio() {
        if (this.audioId != null) {
            cc.audioEngine.stop(this.audioId)
            this.audioId = null
            cc.systemEvent.off('stopMusic', this.stopAudio, this)
        }
    },
    /** 音频id */
    audioId: null,
});
